



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>javascript单元测试(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">javascript单元测试(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 04:30:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1.&#160;&#160;&#160;&#160;&#160; 什么是单元测试</h3>
<p>在计算机编程中，单元测试（又称为模块测试）是针对程序模块(软件设计的最小单位)来进行正确性检验的测试工作。程序单元是应用的最小可测试部件。在过程化编程中，一个单元就是单个程序、函数、过程等；对于面向对象编程，最小单元就是方法，包括基类（超类）、抽象类、或者派生类（子类）中的方法。</p>
<p>每个理想的测试案例独立于其它案例；为测试时隔离模块，经常使用stubs、mock 或fake等测试马甲程序。单元测试通常由软件开发人员编写，用于确保他们所写的代码符合软件需求和遵循开发目标。</p>
<p>单元测试的目标是隔离程序模块并证明这些单个模块是正确的。单元测试能确保在开发过程的早期就能发现问题，是为了让程序“死得更早”。我们应该从开发的早期就为所有函数和方法编写单元测试，可读性强的单元测试可以使程序员方便地检查代码片断是否依然正常工作。良好设计的单元测试案例覆盖程序单元分支和循环条件的所有路径。采用这种自底向上的测试路径，先测试程序模块再测试模块的集合，一旦变更导致错误发生，借助于单元测试可以快速定位并修复错误。</p>
<h3>2.&#160;&#160;&#160;&#160;&#160; JavaScript单元测试现状</h3>
<p>单元测试在后台开发中非常流行和普及，比如JAVA开发者的JUnit等，而在前端开发中则使用的非常少。究其原因，主要是单元测试更适用于逻辑代码的测试，这对于JAVA等后台编程语言来说测试起来非常方便，但是前端开发很多时候要要UI打交道，UI相关的代码不是不可以进行单元测试，但的确很麻烦，比起逻辑代码来说困难多了，这就导致了单元测试在前端开发没有普及起来。</p>
<p>但是随着单元测试的普及，尤其是敏捷开发的推动，涌现了许多优秀的JavaScript单元测试框架，如QUnit、Jasmine等。所有的这些框架基本上都能对Javascript代码进行很好的测试，当然UI部分的代码测试一样比较麻烦，但是我们可以通过精心构造我们的测试代码来测试部分UI代码。但是每个框架都不是万能的，它们都有各自擅长的领域，下面选取了几个具有代表性的框架进行介绍。</p>
<h3>3.&#160;&#160;&#160;&#160;&#160; 单元测试常用框架</h3>
<h4>l&#160;&#160; QUnit框架</h4>
<h5>a)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 简介</h5>
<p>QUnit是jQuery团队开发的JavaScript单元测试工具，功能强大且使用简单。目前所有的JQuery代码都使用QUnit进行测试，原生的JavaScript也可以使用QUnit。</p>
<p>最初，John Resig将QUnit设计为jQuery的一部分。2008年，QUnit才有了自己的名字、主页和API文档，也开始允许其他人用它来做单元测试。但当时QUnit还是基于jQuery的。直到2009年，QUnit才可以完全的独立运行。</p>
<h5>b)&#160;&#160;&#160;&#160;&#160;&#160; 优点</h5>
<p>使用起来非常方便，有漂亮的外观和完整的测试功能（包括异步测试）；</p>
<p>非常简单，容易上手，目前公开的API只有19个；</p>
<p>不需要依赖其它任何软件包或框架，只要能运行JS的地方就可以，QUnit本身只有一个JS文件和CSS文件，当然如果需要可以和jQuery等其它框架集成；</p>
<p>不仅支持在浏览器中测试，还支持在Rhino和node.js等后端测试。</p>
<h5>c)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 不足</h5>
<p>对自动化支持不好，很难和Ant、Maven或自动构建等工具集成，主要用在浏览器中进行测试。</p>
<h5>d)&#160;&#160;&#160;&#160;&#160;&#160; API</h5>
<p>QUnit所有的API可以分为三类：Setup，Assertions，Asynchronous Testing，下面就分别对这些API做些介绍：</p>
<p><strong>Setup:</strong></p>
<p>test( name, [expected], testFun )&#160;&#160; 代表QUnit中的一个测试</p>
<p>name：要测试的名称，比如“加法函数”或“add”等</p>
<p>expected：可选参数，用来表示该测试函数的断言的数量，是个正整数</p>
<p>testFun：一个函数，所有的测试代码都应该包括在该函数里，通常这是一个匿名函数。</p>
<p>例：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>test(“add </code><code>function</code><code>”, 1, </code><code>function</code><code>() { </code></p>
<p><code></code><code>equal(add(1, 2), 3); </code></p>
<p><code>});</code></p>
<p>asyncTest( name, [expected], testFun )&#160;&#160; 代表QUnit中的一个异步测试，参数同test</p>
<p>expect( amount )&#160;&#160; 用在测试函数中，用于声明测试断言的数量，这个函数和test中的expected参数的作用是一样的。主要作用就是检查你声明的个数和你写的断言的实际个数是否一致。</p>
<p>module( name, [lifecycle] )&#160;&#160; 主要用于测试函数的分组，一个module函数为一个分组，比如module(“validate”)表示后面的测试用例都是validate相关的代码，或者module(“common.js”)，表明后面的测试用例都是common.js里面的代码。一个测试文件可以写多个module。</p>
<p>name：分组或者模块的名称</p>
<p>lifecycle：可选参数，它是一个对象，可以设置setup和teardown回调函数</p>
<p>例：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>module(“common.js”,&#160; </code></p>
<p><code></code><code>{ </code></p>
<p><code></code><code>setup:</code><code>function</code><code>(){}, </code></p>
<p><code></code><code>teardown: </code><code>function</code><code>() {}&#160; </code></p>
<p><code></code><code>} </code></p>
<p><code>);</code></p>
<p>setup：在module开始之前执行，可以为该module下面的测试代码做一些准备工作</p>
<p>teardown：将会在该module的所有测试代码执行后执行，比如做一些清理还原工作等。</p>
<p>QUnit.init( )&#160;&#160; 用于初始化QUnit测试框架，通常这个函数是不需要我们手工调用的。</p>
<p>QUnit.reset( )&#160;&#160; 重设函数，通常是在每个test函数执行后由QUnit自己调用来重设整个QUnit测试环境，当然必要时我们自己也可以调用它来复原，不常用。</p>
<p><strong>Assertions:</strong></p>
<p>ok( state, [message] )&#160;&#160; 断言。state值为true时表示通过，否则失败。</p>
<p>equal( actual, expected, [message] )&#160;&#160; 比较参数actual和expected是否相等，相当于 ==</p>
<p>notEqual( actual, expected, [message] )&#160;&#160; 比较两个参数是否不相等，相当于 !=</p>
<p>deepEqual( actual, expected, [message] )&#160;&#160; 主要用于数组和对象等类型的值是否相等，会递归遍历它们所包含的值是否相等。</p>
<p>notDeepEqual( actual, expected, [message] )&#160;&#160; 主要用于数组和对象等类型的值是否不相等，会递归遍历它们所包含的值是否不相等。</p>
<p>strictEqual( actual, expected, [message] )&#160;&#160; 比较两个参数是否严格相等，相当于 ===</p>
<p>notStrictEqual( actual, expected, [message] )&#160;&#160; 比较两个参数是否不严格相等，相当于 !==</p>
<p>throws( block, expected, [message] )&#160;&#160; 测试block函数是否抛出一个异常，抛出则通过，不抛则失败。</p>
<p>block：我们要测试的函数</p>
<p>expected：可选参数，是一个类型，用来验证第一个函数抛出的异常是否是我们预期的类型。</p>
<p>例：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>function</code> <code>CustomError( message ) { </code></p>
<p><code></code><code>this</code><code>.message = message; </code></p>
<p><code>} </code></p>
<p><code></code></p>
<p><code>CustomError.prototype.toString = </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>this</code><code>.message; </code></p>
<p><code>}; </code></p>
<p><code>throws( </code></p>
<p><code></code><code>function</code><code>() { </code></p>
<p><code></code><code>throw</code> <code>new</code> <code>CustomError(“some error description”); </code></p>
<p><code></code><code>}, </code></p>
<p><code></code><code>CustomError, </code></p>
<p><code></code><code>&quot;raised error is an instance of CustomError&quot;</code></p>
<p><code>);</code></p>
<p><strong>Asynchronous Testing:</strong></p>
<p>stop( [increment] )&#160;&#160; 停止测试的运行，用于异步测试。在异步测试时一般先把QUnit的test runner停下来。</p>
<p>increment：增加停止的时间。</p>
<p>start( [decrement] )&#160;&#160; 当异步调用成功后就应该把停止的test runner启动起来让它接着往前跑</p>
<p>decrement：用来减少停止的时间。</p>
<p>例：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>test( </code><code>&quot;a test&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>stop(); </code></p>
<p><code></code><code>var</code> <code>result = </code><code>null</code><code>; </code></p>
<p><code></code><code>$.ajax( </code></p>
<p><code></code><code>url, </code></p>
<p><code></code><code>{}, </code></p>
<p><code></code><code>function</code><code>(data){ </code></p>
<p><code></code><code>result = data; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>); </code></p>
<p><code></code><code>setTimeout(</code><code>function</code><code>() { </code></p>
<p><code></code><code>equals(result, </code><code>&quot;success&quot;</code> <code>); </code></p>
<p><code></code><code>start(); </code></p>
<p><code></code><code>}, 150 ); </code></p>
<p><code>});</code></p>
<h5>e)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 使用</h5>
<p>test.html</p>
<p>导入qunit.css，qunit.js</p>
<p>依次导入被测试文件src.js和测试文件test.js</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321281430.png" /></p>
<p>src.js里是我们要测试的一些函数</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321284616.png" /></p>
<p>test.js里放我们的测试</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321290112.png" /></p>
<p>打开test.html，显示：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321292264.png" /></p>
<p>如果期望值与函数执行的结果不一致，会报错：</p>
<p>test.js</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321293824.png" /></p>
<p>test.html显示：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321295827.png" /></p>
<p>期望值与结果不符，测试不通过。</p>
<p><strong>与浏览器自动化测试工具集成的接口：</strong></p>
<p>都是QUnit自动调用的一些函数，一般不用改，也可以自己定制</p>
<p>QUnit.log(Function({ result, actual, expected, message }))&#160;&#160; 这个接口会在每个断言执行后被自动调用</p>
<p>result：断言是否通过</p>
<p>message：断言里的message参数</p>
<p>例：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>QUnit.log(</code><code>function</code><code>(details){ </code></p>
<p><code></code><code>alert(“Log: ” + details.result + “ ” + details.message); </code></p>
<p><code>})</code></p>
<p>QUnit.testStart(Function({ name }))&#160;&#160; 在每个测试函数执行前被自动调用</p>
<p>name：测试函数中的name参数值</p>
<p>QUnit.testDone(Function({ name, failed, passed, total }))&#160;&#160; 在每个测试函数结束后执行被自动调用</p>
<p>name：同上</p>
<p>failed：指失败断言的个数</p>
<p>passed：指成功断言的个数</p>
<p>total：所有断言的个数</p>
<p>QUnit.moduleStart(Function({ name }))&#160;&#160; 在每个module所有的测试代码执行前被自动调用</p>
<p>name：module函数中name参数的值</p>
<p>QUnit.moduleDone(Function({ name, failed, passed, total }))&#160;&#160; 在每个module所有的测试代码执行完之后被自动执行</p>
<p>failed：指失败断言的个数</p>
<p>passed：指成功断言的个数</p>
<p>total：指所有断言的个数</p>
<p>QUnit.begin(Function())&#160;&#160; 在所有的测试代码调用之前运行</p>
<p>QUnit.done(Function({ failed, passed, total, runtime }))&#160;&#160; 在所有的测试代码调用之后运行</p>
<p>failed：指失败断言的个数</p>
<p>passed：指成功断言的个数</p>
<p>total：指所有断言的个数</p>
<p>runtime：所有代码的执行时间</p>
<p>API及下载：<a href="http://api.qunitjs.com/" rel="external nofollow noreferrer">http://api.qunitjs.com/</a></p>
<p>参考：<a href="http://www.weakweb.com/articles/255.html" rel="external nofollow noreferrer">http://www.weakweb.com/articles/255.html</a></p>
<p><a href="http://www.iteye.com/topic/981253" rel="external nofollow noreferrer">http://www.iteye.com/topic/981253</a></p>
<h4>l&#160; Jasmine框架</h4>
<h5>a)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 简介</h5>
<p>Jasmine是一个有名的JavaScript单元测试框架，它是独立的行为驱动开发框架，语法清晰易懂。</p>
<p><strong>行为驱动开发</strong><strong>(BDD)</strong><strong>：</strong>是一种敏捷软件开发的技术，它鼓励软件项目中的开发者、QA和非技术人员或商业参与者之间的协作。BDD最初是由Dan North在2003年命名，它包括验收和客户测试驱动等的极限编程的实践，作为对测试驱动开发的回应。在过去的数年里，得到了极大的发展。</p>
<p>BDD的重点是通过与利益相关者的讨论取得对预期的软件行为的清醒认识。它通过用自然语言书写非程序员可读的测试用例扩展了测试驱动开发方法。行为驱动开发人员使用混合了领域中统一的语言的母语语言来描述他们的代码的目的。这让开发者得以把精力集中在代码应该怎么写，而不是技术细节上，而且也最大程度的减少了将代码编写者的技术语言与商业客户、用户、利益相关者、项目管理者等的领域语言之间来回翻译的代价。</p>
<p><strong>BDD</strong><strong>的做法包括：</strong></p>
<p>l&#160; 确立不同利益相关者要实现的远景目标</p>
<p>l&#160; 使用特性注入方法绘制出达到这些目标所需要的特性</p>
<p>l&#160; 通过由外及内的软件开发方法，把涉及到的利益相关者融入到实现的过程中</p>
<p>l&#160; 使用例子来描述应用程序的行为或代码的每个单元</p>
<p>l&#160; 通过自动运行这些例子，提供快速反馈，进行回归测试</p>
<p>l&#160; 使用“应当(should)”来描述软件的行为，以帮助阐明代码的职责，以及回答对该软件的功能性的质疑</p>
<p>l&#160; 使用“确保(ensure)”来描述软件的职责，以把代码本身的效用与其他单元(element)代码带来的边际效用中区分出来。</p>
<p>l&#160; 使用mock作为还未编写的相关代码模块的替身</p>
<p><strong>BDD</strong><strong>特性注入：</strong>一个公司可能有多个会带来商业利益的不同愿景，通常包括盈利、省钱或保护钱。一旦某个愿景被开发小组确定为当前条件下的最佳愿景，他们将需要更多的帮助来成功实现这个远景。</p>
<p>然后确定该愿景的主要利益相关者，会带入其他的利益相关者。每个相关者要定义为了实现该愿景他们需要完成的目标。例如，法务部门可能要求某些监管要得到满足。市场营销负责人可能要参加将使用该软件的用户的社区。安全专家需要确保该软件不会受到SQL注入的攻击。</p>
<p>通过这些目标，会定义出要实现这些目标所需要的大概的题目或者特性集合。例如，“允许用户排序贡献值”或“交易审计”。从这些主题，可以确定用户功能以及用户界面的第一批细节。</p>
<h5>b)&#160;&#160;&#160;&#160;&#160;&#160; 优点</h5>
<p>它是基于行为驱动开发实现的测试框架，它的语法非常贴近自然语言，简单明了，容易理解。</p>
<p>能很方便的和Ant、Maven等进行集成进行自动化测试，也可以方便和Jekins等持续集成工具进行集成，可以生成测试结果的XMl文档。</p>
<p>它有丰富的API，同时用户也支持用户扩展它的API，这一点很少有其它框架能够做到。</p>
<p>使用方便简单，只需要引入两个js文件即可</p>
<p>不仅支持在浏览器中测试，还支持在Rhino和node.js等后端测试。</p>
<p>对于Ruby语言有特别的支持，能够非常方便的集成到Ruby项目中去</p>
<h5>c)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 不足</h5>
<p>在浏览器中的测试界面不如QUnit美观、详细。</p>
<h5>d)&#160;&#160;&#160;&#160;&#160;&#160; API</h5>
<p>it(string, function)&#160;&#160; 一个测试Spec</p>
<p>string：测试名称</p>
<p>function：测试函数</p>
<p>describe (string, function)&#160;&#160;&#160; 一个测试组开始于全局函数describe，一个describe是一个it的集合。describe包含n个it，一个it包含n个判断断言&#160; Suite</p>
<p>string：测试组名称</p>
<p>function：测试组函数</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;测试add()函数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>it(</code><code>&quot;1 + 1 = 2&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>expect(add(1, 1)).toBe(2); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>beforeEach(function)&#160;&#160; 定义在一个describe的所有it执行前做的操作</p>
<p>afterEach(function)&#160;&#160; 定义在一个describe的所有it执行后做的操作</p>
<p>expect(a).matchFunction(b)</p>
<p>expect(a).not.matchFunction(b)&#160;&#160; 期望a和b满足匹配方式matchFunction</p>
<p><strong>matchFunctions</strong><strong>：</strong></p>
<p>toBe&#160;&#160; 相当于===，处理简单字面值和变量</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toBe相当于===&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>a = 12; </code></p>
<p><code></code><code>var</code> <code>b = a; </code></p>
<p><code></code><code>expect(a).toBe(b); </code></p>
<p><code></code><code>expect(a).not.toBe(</code><code>null</code><code>); </code></p>
<p><code></code><code>expect(</code><code>false</code> <code>== 0).toBe(</code><code>true</code><code>); </code></p>
<p><code>}); </code></p>
<p><code>it(</code><code>&quot;toBe不能当==用&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>expect(</code><code>false</code><code>).toBe(0); </code></p>
<p><code>});</code></p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321344610.png" /></p>
<p>toEqual&#160;&#160; 处理简单字面值和变量，而且可以处理对象，数组</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toEqual可以处理字面值，变量和对象&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>a = 12; </code></p>
<p><code></code><code>expect(a).toEqual(12); </code></p>
<p><code></code><code>var</code> <code>foo = {key : </code><code>&quot;key&quot;</code><code>}; </code></p>
<p><code></code><code>var</code> <code>bar = {key : </code><code>&quot;key&quot;</code><code>}; </code></p>
<p><code></code><code>expect(foo).toEqual(bar); </code></p>
<p><code></code><code>var</code> <code>arr1 = []; </code></p>
<p><code></code><code>arr1[</code><code>&quot;p1&quot;</code><code>] = </code><code>&quot;string1&quot;</code><code>; </code></p>
<p><code></code><code>var</code> <code>arr2 = []; </code></p>
<p><code></code><code>arr2[</code><code>&quot;p1&quot;</code><code>] = </code><code>&quot;string1&quot;</code><code>; </code></p>
<p><code></code><code>var</code> <code>obj = {}; </code></p>
<p><code></code><code>obj[</code><code>&quot;p1&quot;</code><code>] = </code><code>&quot;string1&quot;</code><code>; </code></p>
<p><code></code><code>expect(arr1).toEqual(arr2); </code></p>
<p><code></code><code>expect(arr1).toEqual(obj); </code></p>
<p><code>});</code></p>
<p>toMatch&#160;&#160; 按正则式检索。</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toMatch匹配正则式&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>message = </code><code>&quot;foo bar baz&quot;</code><code>; </code></p>
<p><code></code><code>expect(message).toMatch(/bar/); </code></p>
<p><code></code><code>expect(message).toMatch(</code><code>&quot;bar&quot;</code><code>); </code></p>
<p><code></code><code>expect(message).not.toMatch(/quux/); </code></p>
<p><code></code><code>expect(message).toMatch(/^f/); </code></p>
<p><code></code><code>expect(message).not.toMatch(/f$/); </code></p>
<p><code>});</code></p>
<p>toBeDefined&#160;&#160; 是否已声明且赋值</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toBeDefined检测变量非undefined&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>a = { key : </code><code>&quot;key&quot;</code><code>}; </code></p>
<p><code></code><code>expect(a.key).toBeDefined(); </code></p>
<p><code></code><code>expect(a.foo).not.toBeDefined(); </code></p>
<p><code></code><code>//expect(c).not.toBeDefined();&#160; //未声明出错 </code></p>
<p><code></code><code>var</code> <code>b; </code></p>
<p><code></code><code>expect(b).not.toBeDefined(); </code></p>
<p><code>});</code></p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 对象.未声明属性.not.toBeDefined();&#160;&#160; 通过</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 未声明变量.not.toBeDefined();&#160;&#160;&#160;&#160;&#160;&#160; 报错</p>
<p>toBeUndefined&#160;&#160;&#160;&#160;&#160; 是否undefined</p>
<p>toBeNull&#160;&#160; 是否null</p>
<p>toBeTruthy&#160;&#160; 如果转换为布尔值，是否为true</p>
<p>toBeFalsy&#160;&#160;&#160; 如果转换为布尔值，是否为false</p>
<p>toContain&#160;&#160; 数组中是否包含元素（值）。只能用于数组，不能用于对象</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toContain检验数组中是否包含元素(值)&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>a = [</code><code>&quot;foo&quot;</code><code>, </code><code>&quot;bar&quot;</code><code>, </code><code>&quot;baz&quot;</code><code>]; </code></p>
<p><code></code><code>expect(a).toContain(</code><code>&quot;bar&quot;</code><code>); </code></p>
<p><code>});</code></p>
<p>toBeLessThan&#160;&#160; 数值比较，小于</p>
<p>toBeGreaterThan&#160;&#160; 数值比较，大于</p>
<p>toBeCloseTo&#160;&#160; 数值比较时定义精度，先四舍五入后再比较</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toBeCloseTo数值比较，指定精度，先四舍五入再比较&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>pi = 3.1415926, e = 2.78; </code></p>
<p><code></code><code>expect(pi).toBeCloseTo(e, 0); </code></p>
<p><code></code><code>expect(pi).not.toBeCloseTo(e, 0.1); </code></p>
<p><code>});</code></p>
<p>toThrow&#160;&#160;&#160; 检验一个函数是否会抛出一个错误</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>it(</code><code>&quot;toThrow检验一个函数是否会抛出一个错误&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo = </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>1 + 2; </code></p>
<p><code></code><code>}; </code></p>
<p><code></code><code>var</code> <code>bar = </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>a + 1; </code></p>
<p><code></code><code>}; </code></p>
<p><code></code><code>expect(foo).not.toThrow(); </code></p>
<p><code></code><code>expect(bar).toThrow(); </code></p>
<p><code>});</code></p>
<p>注：describe可嵌套</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; xdescribe 和 xit：路过不执行，结果不显示。像display:none。点控制栏中skipped显示</p>
<p>Spy&#160;&#160; 存储函数的被调用情况和参数（函数监视器，记录被调用情况，但函数并不真执行）</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;对spy函数的测试&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo, bar = </code><code>null</code><code>; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>foo = { </code></p>
<p><code></code><code>setBar: </code><code>function</code><code>(value) { </code></p>
<p><code></code><code>bar = value; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>}; </code></p>
<p><code></code></p>
<p><code></code><code>spyOn(foo, </code><code>'setBar'</code><code>);&#160; </code><code>//foo为spy函数 </code></p>
<p><code></code></p>
<p><code></code><code>foo.setBar(123); </code></p>
<p><code></code><code>foo.setBar(456, </code><code>'another param'</code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo函数是否被调用过&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.setBar).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo函数被调用的次数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.setBar.calls.length).toEqual(2); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo函数被调用时传入的参数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.setBar).toHaveBeenCalledWith(123); </code></p>
<p><code></code><code>expect(foo.setBar).toHaveBeenCalledWith(456, </code><code>'another param'</code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;上一次被调用的参数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.setBar.mostRecentCall.args[0]).toEqual(456); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;所有被调用的情况存在一个数组里&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.setBar.calls[0].args[0]).toEqual(123); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;函数并未真的执行&quot;</code><code>, </code><code>function</code><code>() {&#160;&#160; </code></p>
<p><code></code><code>expect(bar).toBeNull();&#160;&#160; </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>Spy addCallThrough&#160; 函数监视器，但函数真的执行</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;对spy函数的测试，函数真的执行&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo, bar, fetchedBar; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>foo = { </code></p>
<p><code></code><code>setBar: </code><code>function</code><code>(value) { </code></p>
<p><code></code><code>bar = value; </code></p>
<p><code></code><code>}, </code></p>
<p><code></code><code>getBar: </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>bar; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>}; </code></p>
<p><code></code></p>
<p><code></code><code>//spyOn(foo, &quot;setBar&quot;);&#160;&#160;&#160; //如果加上这句，setBar不真的执行，后两个spec不通过 </code></p>
<p><code></code><code>spyOn(foo, </code><code>'getBar'</code><code>).andCallThrough(); </code></p>
<p><code></code></p>
<p><code></code><code>foo.setBar(123); </code></p>
<p><code></code><code>fetchedBar = foo.getBar(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo中getBar函数是否被调用过&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.getBar).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;foo中setBar函数真的执行了&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(bar).toEqual(123); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;foo中getBar函数真的执行了&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(fetchedBar).toEqual(123); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>Spy andReturn&#160; 函数监视器，函数不真的执行。指定监视的函数的返回值</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;A spy, when faking a return value&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo, bar, fetchedBar; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>foo = { </code></p>
<p><code></code><code>setBar: </code><code>function</code><code>(value) { </code></p>
<p><code></code><code>bar = value; </code></p>
<p><code></code><code>}, </code></p>
<p><code></code><code>getBar: </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>bar; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>}; </code></p>
<p><code></code></p>
<p><code></code><code>spyOn(foo, </code><code>'getBar'</code><code>).andReturn(745);&#160; </code><code>//指定getBar函数返回745 </code></p>
<p><code></code></p>
<p><code></code><code>foo.setBar(123); </code></p>
<p><code></code><code>fetchedBar = foo.getBar(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo中getBar函数是否被调用过&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.getBar).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;不影响未被监视的其它函数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(bar).toEqual(123); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;指定的返回值745&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(fetchedBar).toEqual(745); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>Spy addCallFake&#160; 替代被监视的函数，原函数不执行</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;替代被监视的函数，原函数不执行&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo, bar, fetchedBar; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>foo = { </code></p>
<p><code></code><code>setBar: </code><code>function</code><code>(value) { </code></p>
<p><code></code><code>bar = value; </code></p>
<p><code></code><code>}, </code></p>
<p><code></code><code>getBar: </code><code>function</code><code>() { </code></p>
<p><code></code><code>alert(</code><code>&quot;frostbelt&quot;</code><code>); </code></p>
<p><code></code><code>return</code> <code>bar; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>}; </code></p>
<p><code></code></p>
<p><code></code><code>spyOn(foo, </code><code>'getBar'</code><code>).andCallFake(</code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>1001; </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>foo.setBar(123); </code></p>
<p><code></code><code>fetchedBar = foo.getBar(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;测试foo中getBar函数是否被调用过&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(foo.getBar).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;不影响未被监视的其它函数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(bar).toEqual(123); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;getBar被addCallFake指定的匿名函数代替，getBar不执行&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(fetchedBar).toEqual(1001); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>如果你没有什么可监视的又实在想监视一下，该咋办？自己create一个被监视函数。。</p>
<p>jasmine.createSpy(functionId)</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;自己造一个被监视函数。啊，我凌乱了。。&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>whatAmI; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>whatAmI = jasmine.createSpy(</code><code>'whatAmI'</code><code>); </code></p>
<p><code></code></p>
<p><code></code><code>whatAmI(</code><code>&quot;I&quot;</code><code>, </code><code>&quot;am&quot;</code><code>, </code><code>&quot;a&quot;</code><code>, </code><code>&quot;spy&quot;</code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;有个id，是createSpy的传入函数，用于报错&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(whatAmI.identity).toEqual(</code><code>'whatAmI'</code><code>) </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;是否被调用&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(whatAmI).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;被调用的次数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(whatAmI.calls.length).toEqual(1); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;被调用的参数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(whatAmI).toHaveBeenCalledWith(</code><code>&quot;I&quot;</code><code>, </code><code>&quot;am&quot;</code><code>, </code><code>&quot;a&quot;</code><code>, </code><code>&quot;spy&quot;</code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;最近一次被调用&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(whatAmI.mostRecentCall.args[0]).toEqual(</code><code>&quot;I&quot;</code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>有时需要监视一个对象的很多方法，用createSpyObj添加方法数组</p>
<p>jasmine.createSpyObj(obj, methodArray)</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;有时需要监视一个对象的很多个方法，用createSpyObj添加数组&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>tape; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>tape = jasmine.createSpyObj(</code><code>'tape'</code><code>, [</code><code>'play'</code><code>, </code><code>'pause'</code><code>, </code><code>'stop'</code><code>, </code><code>'rewind'</code><code>]); </code></p>
<p><code></code></p>
<p><code></code><code>tape.play(); </code></p>
<p><code></code><code>tape.pause(); </code></p>
<p><code></code><code>tape.rewind(0); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;tape对象的这四个方法已被定义&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(tape.play).toBeDefined(); </code></p>
<p><code></code><code>expect(tape.pause).toBeDefined(); </code></p>
<p><code></code><code>expect(tape.stop).toBeDefined(); </code></p>
<p><code></code><code>expect(tape.rewind).toBeDefined(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;四个方法是否被调用&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(tape.play).toHaveBeenCalled(); </code></p>
<p><code></code><code>expect(tape.pause).toHaveBeenCalled(); </code></p>
<p><code></code><code>expect(tape.rewind).toHaveBeenCalled(); </code></p>
<p><code></code><code>expect(tape.stop).not.toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;被调用时传入的参数&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect(tape.rewind).toHaveBeenCalledWith(0); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>jasmine.any&#160;&#160; 类型判断。instanceof</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;类型匹配&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>it(</code><code>&quot;相当于instanceof&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>expect({}).toEqual(jasmine.any(Object)); </code></p>
<p><code></code><code>expect(12).toEqual(jasmine.any(Number)); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;也可以用于spy&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>foo = jasmine.createSpy(</code><code>'foo'</code><code>); </code></p>
<p><code></code><code>foo(12, </code><code>function</code><code>() { </code></p>
<p><code></code><code>return</code> <code>true</code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>expect(foo).toHaveBeenCalledWith(jasmine.any(Number), jasmine.any(Function)); </code></p>
<p><code></code><code>//foo被调用时的参数 类型判断 </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>jasmine.Clock.useMock()&#160;&#160; jasmine自己控制时间，实现异步调试，减少等待</p>
<p>jasmine.Clock.tick(n:uint)&#160;&#160; 向前n毫秒</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;jasmine自己控制时间，实现异步调试，减少等待&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>timerCallback;&#160; </code></p>
<p><code></code></p>
<p><code></code><code>beforeEach(</code><code>function</code><code>() { </code></p>
<p><code></code><code>timerCallback = jasmine.createSpy(</code><code>'timerCallback'</code><code>); </code></p>
<p><code></code><code>jasmine.Clock.useMock(); </code></p>
<p><code></code><code>});&#160; </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;setTimeout&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>setTimeout(</code><code>function</code><code>() { </code></p>
<p><code></code><code>timerCallback(); </code></p>
<p><code></code><code>}, 100); </code></p>
<p><code></code></p>
<p><code></code><code>expect(timerCallback).not.toHaveBeenCalled(); </code></p>
<p><code></code></p>
<p><code></code><code>jasmine.Clock.tick(101); </code></p>
<p><code></code></p>
<p><code></code><code>expect(timerCallback).toHaveBeenCalled(); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;setInterval&quot;</code><code>, </code><code>function</code><code>() { </code></p>
<p><code></code><code>setInterval(</code><code>function</code><code>() { </code></p>
<p><code></code><code>timerCallback(); </code></p>
<p><code></code><code>}, 100); </code></p>
<p><code></code></p>
<p><code></code><code>expect(timerCallback).not.toHaveBeenCalled(); </code></p>
<p><code></code></p>
<p><code></code><code>jasmine.Clock.tick(101); </code></p>
<p><code></code><code>expect(timerCallback.callCount).toEqual(1); </code></p>
<p><code></code></p>
<p><code></code><code>jasmine.Clock.tick(50); </code></p>
<p><code></code><code>expect(timerCallback.callCount).toEqual(1); </code></p>
<p><code></code></p>
<p><code></code><code>jasmine.Clock.tick(50); </code></p>
<p><code></code><code>expect(timerCallback.callCount).toEqual(2); </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>注：在这种环境下setTimeout和setInterval的callback为同步的，系统时间不再影响执行</p>
<p>runs(function)&#160; waitsFor(function, message, millisec)&#160;&#160; Jasmine异步调试&#160; 按自己的理解写个例子</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>describe(</code><code>&quot;jasmine异步调试，对ajax结果的断言&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>var</code> <code>data, flag = </code><code>false</code><code>; </code></p>
<p><code></code></p>
<p><code></code><code>it(</code><code>&quot;ajax是否按时返回了正确结果&quot;</code><code>, </code><code>function</code><code>(){ </code></p>
<p><code></code><code>runs(</code><code>function</code><code>(){ </code></p>
<p><code></code><code>$.post( </code></p>
<p><code></code><code>url, </code></p>
<p><code></code><code>{}, </code></p>
<p><code></code><code>function</code><code>(data){ </code></p>
<p><code></code><code>flag = </code><code>true</code><code>; </code></p>
<p><code></code><code>data = data.someAttr; </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>); </code></p>
<p><code></code><code>}); </code></p>
<p><code></code></p>
<p><code></code><code>waitsFor(</code><code>function</code><code>(){&#160; </code><code>//flag为true或到2秒时执行&#160; 2秒内返回true则执行最后一个runs，到时未返回则本spec出错，返回第二个参数错误信息 </code></p>
<p><code></code><code>return</code> <code>flag; </code></p>
<p><code></code><code>}, </code><code>&quot;ajax在指定时间2秒内未返回&quot;</code><code>, 2000); </code></p>
<p><code></code></p>
<p><code></code><code>runs(</code><code>function</code><code>(){&#160; </code><code>//直到waitsFor返回true时执行 </code></p>
<p><code></code><code>expect(data).toEqual(</code><code>&quot;someThing&quot;</code><code>); </code></p>
<p><code></code><code>}) </code></p>
<p><code></code><code>}); </code></p>
<p><code>});</code></p>
<p>注：it是一个spec，包含</p>
<p>runs(function)</p>
<p>waitsFor(function, message, millsec)</p>
<p>runs(function)</p>
<p>第一个runs里有一些异步的代码</p>
<p>waitsFor中的funciton如果在millsec内返回true，执行最后一个runs</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 如果在millsec内不能返回true，spec不通过，显示错误信息message</p>
<p>原文代码：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321430338.png" /></p>
<h5>e)&#160;&#160;&#160;&#160;&#160;&#160;&#160; 使用</h5>
<p>在测试的页面里加入以下代码：</p>
<p><a href="http://www.cnblogs.com/frostbelt/archive/2012/08/03/2622302.html#" rel="external nofollow noreferrer">?</a></p>
<p><code>&lt;script type=</code><code>&quot;text/javascript&quot;</code><code>&gt; </code></p>
<p><code></code><code>(</code><code>function</code><code>() { </code></p>
<p><code></code><code>var</code> <code>jasmineEnv = jasmine.getEnv(); </code></p>
<p><code></code><code>jasmineEnv.updateInterval = 1000; </code></p>
<p><code></code><code>var</code> <code>trivialReporter = </code><code>new</code> <code>jasmine.TrivialReporter(); </code></p>
<p><code></code><code>jasmineEnv.addReporter(trivialReporter); </code></p>
<p><code></code><code>jasmineEnv.specFilter = </code><code>function</code><code>(spec) { </code></p>
<p><code></code><code>return</code> <code>trivialReporter.specFilter(spec); </code></p>
<p><code></code><code>}; </code></p>
<p><code></code><code>var</code> <code>currentWindowOnload = window.onload; </code></p>
<p><code></code><code>window.onload = </code><code>function</code><code>() { </code></p>
<p><code></code><code>if</code> <code>(currentWindowOnload) { </code></p>
<p><code></code><code>currentWindowOnload(); </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>execJasmine(); </code></p>
<p><code></code><code>}; </code></p>
<p><code></code><code>function</code> <code>execJasmine() { </code></p>
<p><code></code><code>jasmineEnv.execute(); </code></p>
<p><code></code><code>} </code></p>
<p><code></code><code>})(); </code></p>
<p><code>&lt;/script&gt;</code></p>
<p>导入jasmine.css&#160; jasmine.js&#160; jasmine-html.js</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; src.js(源代码)&#160; test.js(存放describes)</p>
<p>参考：<a href="http://www.weakweb.com/articles/255.html" rel="external nofollow noreferrer">http://www.weakweb.com/articles/255.html</a></p>
<p><a href="http://pivotal.github.com/jasmine/" rel="external nofollow noreferrer">http://pivotal.github.com/jasmine/</a></p>
<p>下载：<a href="https://github.com/pivotal/jasmine/downloads" rel="external nofollow noreferrer">https://github.com/pivotal/jasmine/downloads</a></p>
<h4>l&#160; JsTestDriver</h4>
<p><strong>a)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>简介</strong></p>
<p>JsTestDriver是一个JavaScript单元测试工具，易于与持续构建系统相集成并能够在多个浏览器上运行测试轻松实现TDD风格的开发。当在项目中配置好JsTestDriver以后，如同junit测试java文件一般，JsTestDriver可以直接通过运行js文件来进行单元测试。JsTestDriver框架本身就是JAVA的jar包，需要在本地运行并监听一个端口。</p>
<p><strong>b)&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>优点</strong></p>
<p>可以一次测试多个浏览器，使用方法是在启动服务时可以将多个浏览器的路径作为参数传进去。可以在多台机器上的浏览器中运行，包括移动设备。</p>
<p>测试运行得很快，因为不需要将结果添加到DOM中呈现出来，它们能够同时在任意多的浏览器中运行，未修改的文件浏览器会从缓存提取。</p>
<p>不需要HTML配件文件，仅仅只需提供一个或多个脚本和测试脚本，测试运行器运行时会创建一个空文件。</p>
<p>能很方便的和Ant、Maven等进行集成进行自动化测试，也可以方便和Jekins等持续集成工具进行集成，可以生成测试结果的XML文档。</p>
<p>有Eclipse和IntelliJ插件，可以很方便的在这两个IDE中进行测试，和JUnit很像。</p>
<p>支持其它测试框架，可以测试其它测试框架写的测试代码，比如有对应的插件可以将QUnit和Jasmine测试代码转换成JsTestDriver的测试代码。</p>
<p><strong>c)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>不足</strong></p>
<p>不能在浏览器中测试，只能通过自动化工具或控制台运行。生成的结果不够直观。</p>
<p>安装使用稍微有点麻烦，依赖于JAVA环境。</p>
<p><strong>d)&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>API</strong></p>
<p>assert(msg, value)</p>
<p>assertTrue(msg, value)</p>
<p>assertFalse(msg, value)</p>
<p>assertEquals(msg, expected, actual)</p>
<p>assertNotEquals(msg, expected, actual)</p>
<p>assertSame(msg, expected, actual)</p>
<p>assertNotSame(msg, expected, actual)</p>
<p>assertNull(msg, value)</p>
<p>assertNotNull(msg, value)</p>
<p>assertUndefined(msg, value)</p>
<p>assertNotUndefined(msg, value)</p>
<p>assertNaN(msg, number)</p>
<p>assertNotNaN(msg, number)</p>
<p>assertException(msg, callback, type)</p>
<p>assertNoException(msg, callback)</p>
<p>assertArray(msg, arrayLike)</p>
<p>assertTypeOf(msg, type, object)</p>
<p>assertBoolean(msg, value)</p>
<p>assertFunction(msg, value)</p>
<p>assertNumber(msg, value)</p>
<p>assertObject(msg, value)</p>
<p>assertString(msg, value)</p>
<p>assertMatch(msg, pattern, string)</p>
<p>assertNoMatch(msg, pattern, string)</p>
<p>assertTagName(msg, tagName, element)</p>
<p>assertClassName(msg, className, element)</p>
<p>assertElementId(msg, id, element)</p>
<p>assertInstanceOf(msg, constructor, object)</p>
<p>assertNotInstanceOf(msg, constructor, object)</p>
<p>API按字面意思理解即可，不一一标注</p>
<p><strong>e)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>使用</strong></p>
<p>前提：</p>
<p>安装java环境</p>
<p>下载JsTestDriver.jar</p>
<p>目录：</p>
<p>JsTestDriver.jar</p>
<p>jsTestDriver.conf&#160;&#160;&#160;&#160;&#160;&#160;&#160; //配置文件，默认名称，如果用其它名称，需要指定config参数</p>
<p>src</p>
<p>----src.js</p>
<p>test</p>
<p>----test.js</p>
<p>jsTestDriver.conf：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321462212.png" /></p>
<p>src.js：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321464039.png" /></p>
<p>test.js：</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321465577.png" /></p>
<p>像java的JUnit一样，测试方法名要以”test”开头，如：”testXXXX”</p>
<p>测试步骤：</p>
<ol><li>cmd 进入目录</li>
<li>运行命令”java –jar JsTestDriver.jar –port 9876”</li>
<li>打开页面<a href="http://localhost:9876/" rel="external nofollow noreferrer">http://localhost:9876</a>，点击“捕获浏览器”。</li>
<li>新打开一个终端，运行命令”java –jar JsTestDriver.jar –tests all”，运行所有测试用例</li>
<li>也可以单独运行某一个用例，如运行命令” java –jar JsTestDriver.jar –tests addTest.testA”</li></ol>
<p>安装：<a href="http://code.google.com/p/js-test-driver/wiki/UsingTheEclipsePlugin" rel="external nofollow noreferrer">http://code.google.com/p/js-test-driver/wiki/UsingTheEclipsePlugin</a></p>
<p>下载：<a href="http://code.google.com/p/js-test-driver/" rel="external nofollow noreferrer">http://code.google.com/p/js-test-driver/</a></p>
<p>参考：《测试驱动的JavaScript开发》</p>
<h4>l&#160; FireUnit</h4>
<p><strong>a)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>简介</strong></p>
<p>FireUnit是一个基于Firebug的Javascript的单元测试框架。简单说来，FireUnit给Firebug增加了一个标签面板，并提供了一些简单的JavaScript API来记录和查看测试。</p>
<p><strong>b)&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>优点</strong></p>
<p>简单易用</p>
<p><strong>c)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>不足</strong></p>
<p>功能不多，测试代码常常写在源码里，虽然可以实时地看到效果，但耦合太强，不易清理</p>
<p>只运行在Firefox下</p>
<p><strong>d)&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>API</strong></p>
<p>常用：</p>
<p>fireunit.ok(condition, message)&#160;&#160; true/false</p>
<p>fireunit.compare(actual, expect, message)&#160;&#160; 是否相等</p>
<p>fireunit.reCompare(regexp, string, message)&#160;&#160; 字符串是否与正则式匹配</p>
<p>fireunit.testDone();&#160;&#160; 执行以上的测试，在Firebug的新标签test中显示结果</p>
<p>其它：</p>
<p>fireunit.runTests(“test2.html”, “test3.html”)&#160;&#160; 一起运行多个页面的测试(每个文件都含有一些独立的测试)</p>
<p>fireunit.log(message)&#160;&#160; 打印log，但似乎不管用</p>
<p>fireunit.id(id)&#160;&#160; 相当与document.getElementById</p>
<p>fireunit.click(element)&#160;&#160; 模拟触发element的click事件</p>
<p>fireunit.focus(element)&#160;&#160; 模拟触发element的focus事件</p>
<p>fireunit.mouseDown(element)&#160;&#160; 模拟触发element的mouseDown事件</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 但看代码明明是click事件</p>
<p><img referrerpolicy="no-referrer"src="http://pic002.cnblogs.com/images/2012/135584/2012080321472154.png" /></p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 在FF下，只是执行了node.click();不会触发onmousedown，只会触发onclick。已验证</p>
<p>fireunit.value(element)&#160;&#160; 修改element的value</p>
<p>fireunit.key(element, key)&#160;&#160; 模拟触发element的key事件</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; 例：</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; var input = document.getElementsByTagName(“input”)[0];</p>
<p>&#160;&#160;&#160;&#160;&#160;&#160; fireunit.key(input, “a”);</p>
<p>没用过：</p>
<p>fireunit.browser</p>
<p>fireunit.test</p>
<p>fireunit.forceHTTP</p>
<p>fireunit.registerPathHandler</p>
<p>fireunit.panel</p>
<p>fireunit.privilege</p>
<p><strong>e)&#160;&#160;&#160;&#160;&#160;&#160;&#160; </strong><strong>使用</strong></p>
<p>在FF下装Firebug和FireUnit</p>
<p>直接在代码里写测试，就像console.log();</p>
<p>参考：<a href="https://github.com/jeresig/fireunit/wiki/internals" rel="external nofollow noreferrer">https://github.com/jeresig/fireunit/wiki/internals</a></p>
<p><a href="http://hi.baidu.com/dearhwj/blog/item/1d1e0dbfc380f80219d81f35.html" rel="external nofollow noreferrer">http://hi.baidu.com/dearhwj/blog/item/1d1e0dbfc380f80219d81f35.html</a></p>
<h3>4.&#160;&#160;&#160;&#160;&#160; 小结</h3>
<p>QUnit框架简单方便，测试界面直观详细</p>
<p>Jasmine功能强大，风格也简单明了，符合前端开发者的编程习惯，推荐</p>
<p>JsTestDriver可以和QUnit等框架结合，可以同时测多个浏览器。但安装复杂，只能在控制台显示，不友好，不够清晰</p>
<p>FireUnit小巧灵活，加上Firebug的人气应该很受欢迎</p>
<p>如果需要进行自动化测试， 多了解一下Jasmine和JsTestDriver，本文未深入。</p>
<h3>5.&#160;&#160;&#160;&#160;&#160; 附注</h3>
<p>JavaScript单元测试框架<a href="http://en.wikipedia.org/wiki/List_of_unit_testing_frameworks#JavaScript" rel="external nofollow noreferrer">详细列表</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvdxy8.html">无参数实例化Configuration对象以及addResource无法加载core-site&period;xml中的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql7ype9.html">JAVA数组的典型操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24k1x8.html">jQuery获取浏览器URL链接的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1y2v19.html">R中将list类型数据转换成data&period;frame型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnd760q.html">django如何检查创建的模型（model）是否有语法错误或者逻辑错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd55kk8.html">使用Drush管理Drupal站点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm52569.html">SQL IDENTITY&lpar;int&comma;1&comma;1&rpar;  用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96od4o49.html">HDU 5833 Zhu and 772002 （高斯消元）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd3j778.html">ElasticSearch elasticsearch-servicewrapper 在linux上的安装部署全程记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okr3r59.html">C&num; 自动登录网页，浏览页面【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyp51q.html">关于centos6&period;5系统安装FTP服务和配置的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2won6lq.html">初次使用Oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0z278.html">Visual Studio 2017 离线安装方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpkvnjq.html">关于SQL语句条件值写中文查不到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxd67q.html">nat的翻译类型（2）--动态nat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkm4vz8.html">轻松解决oracle11g 空表不能exp导出的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrkkx9.html">jdk源码阅读笔记-String</a>
		</li>
						<li><a href="https://www.batexi.com/a/960d3jn9.html">codeforces 1106 E</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kz5eq.html">MySQL 存储修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyl0239.html">GUI&lowbar;键盘事件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj16049.html">苹果 App 转移图文详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd7yvz8.html">angular学习&lpar;一&rpar;&colon;动态模板总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmnvj09.html">简单的web三层架构系统【第一版】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z15n219.html">Matlab常用小技巧及部分快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd7gmk8.html">Java 网络编程（五） 使用TCP&sol;IP的套接字（Socket）进行通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x5e6v8.html">【转】OpenCV与CxImage转换&lpar;IplImage&rpar;、IplImage QImage Mat 格式互转</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdjxzm8.html">POJ 2689 Prime Distance（素数筛选）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdjoj78.html">在IT公司，project manager 基本上和秘书，助理什么的差不多</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjmj628.html">Ext JS学习第六天 Ext&lowbar;window组件（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljej0k9.html">c 有关N&excl;阶乘的相关问题----陆续补充上来</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
